using System;
using System.Collections.Generic;
using Oxide.Core;
using System.Linq;

namespace Oxide.Plugins
{
    // Edit by Mroczny
    [Info("Maths", "by.Hasky", 1.5)]
    [Description("Maths")]
    public class Maths : HurtworldPlugin
    {
        void Init()
        {
            LoadData();
        }

        protected override void LoadDefaultConfig()
        {
            if (Config["Time"] == null) Config.Set("Time", 7200);
            if (Config["MathStart"] == null) Config.Set("MathStart", "<color=#33ff99>[Matematyka]</color> Rozwiąż dobrze zadanie i wygraj cenne itemki: <color=#0066ff>{math}</color> ");
            if (Config["MathEnd"] == null) Config.Set("MathEnd", "<color=#33ff99>[Matematyka]</color> <color=#0066ff>{name}</color> dobrze rozwiązał i otrzywał: <color=#0066ff>{itemName}</color> <color=#0099ff>(x{amount})</color>!");
            SaveConfig();
        }

        public List<MathsData> Chat = new List<MathsData>();

        public class MathsData
        {
            public MathsData(string answer, ulong user)
            {

                this.answer = answer;
                this.user = user;
            }


            public string answer { get; set; }
            public ulong user { get; set; }

        }

        private void OnServerInitialized()
        {
            int p1;
            int p2;
            int p3;
            string answer;

            timer.Repeat(Convert.ToSingle(Config["Time"]), 0, () =>
            {
                p1 = Core.Random.Range(70, 250);
                p2 = Core.Random.Range(1, 5);
                p3 = Core.Random.Range(1, 50);
                answer = $"{(p1 * p2) - p3}";
                var checkChat2 = (from x in Chat where x.user == 0 select x).Count();
                if (checkChat2 == 0)
                {
                    string math = $"{p1}*{p2}-{p3}";
                    Server.Broadcast($"{Config["MathStart"]}"
                        .Replace("{math}", math));

                    Chat.Add(new MathsData(answer, 0));
                }
                else
                {
                    var checkChat3 = (from x in Chat where x.user == 0 select x).FirstOrDefault();
                    Chat.Remove(checkChat3);
                }
                SaveData();
                return;
            });
        }

        void OnPlayerChat(PlayerSession session, string msg)
        {
            int checkChat;
            checkChat = (from x in Chat where x.user == 0 select x).Count();
            if (checkChat > 0)
            {
                foreach (var Answer in Chat)
                {
                    int itemid;
                    int amount;
                    string itemName;


                    itemid = 231;
                    itemName = "Detonator Cap";
                    amount = 1;


                    if (msg == Answer.answer && Answer.user == 0)
                    {
                        Singleton<GlobalItemManager>.Instance.GiveItem(session.Player, Singleton<GlobalItemManager>.Instance.GetItem(itemid), amount);
                        Server.Broadcast($"{Config["MathEnd"]}"
                            .Replace("{name}", session.Name)
                            .Replace("{itemName}", itemName)
                            .Replace("{amount}", amount.ToString()));

                        Answer.user = (ulong)session.SteamId;

                    }
                }

            }
            else return;

            SaveData();

            return;
        }

        void LoadData()
        {
            Chat = Interface.Oxide.DataFileSystem.ReadObject<List<MathsData>>("MathsData");
        }

        void SaveData()
        {
            Interface.Oxide.DataFileSystem.WriteObject("MathsData", Chat);
        }
    }
}